package ru.amse.cat.evlarchick.textstructure;

public class Segment implements ISegment {
    protected int myStart;
    protected int myEnd;
    protected final ITextStructure myTS;

    protected Segment(ITextStructure ts) {
        myTS = ts;
        myStart = -2;
        myEnd = -1;
    }

    public Segment(int start, int end, ITextStructure ts) throws SegmentIsTooBigException {
        if (!ts.isIndicesUseable(this, start, end)) {
            throw new SegmentIsTooBigException(start, end);
        }

        myStart = start;
        myEnd = end;
        myTS = ts;
    }

    public static ISegment createSegment(ITextStructure ts) {
        return new Segment(ts);
    }

    public int getStart() {
        return myStart;
    }

    public boolean setStart(int start) {
        if (!myTS.isIndicesUseable(this, start, myEnd)) {
            return false;
        }
        myStart = start;
        return true;
    }

    public int getEnd() {
        return myEnd;
    }

    public boolean setEnd(int end) {
        if (!myTS.isIndicesUseable(this, myStart, end)) {
            return false;
        }
        myEnd = end;
        return true;
    }

    public String toString() {
        return "["+myStart +", " + myEnd+"]";
    }
}
